diff -ruN vdr-1.3.31/remux.c vdr-1.3.32/remux.c
--- vdr-1.3.31/remux.c	2005-08-28 13:46:44.000000000 +0200
+++ vdr-1.3.32/remux.c	2005-09-11 15:26:50.000000000 +0200
@@ -11,7 +11,7 @@
  * The cRepacker family's code was originally written by Reinhard Nissl <rnissl@gmx.de>,
  * and adapted to the VDR coding style by Klaus.Schmidinger@cadsoft.de.
  *
- * $Id: remux.c 1.42 2005/08/28 11:46:44 kls Exp $
+ * $Id: remux.c 1.47 2005/09/11 13:26:50 kls Exp $
  */
 
 #include "remux.h"
@@ -98,7 +98,7 @@
   static int Put(cRingBufferLinear *ResultBuffer, const uchar *Data, int Count, int CapacityNeeded);
   cRepacker(void) { initiallySyncing = true; maxPacketSize = 6 + 65535; subStreamId = 0; }
   virtual ~cRepacker() {}
-  virtual void Reset(void) { /* initiallySyncing = true; */ }
+  virtual void Reset(void) { initiallySyncing = true; }
   virtual void Repack(cRingBufferLinear *ResultBuffer, const uchar *Data, int Count) = 0;
   virtual int BreakAt(const uchar *Data, int Count) = 0;
   virtual int QuerySnoopSize(void) { return 0; }
@@ -142,7 +142,7 @@
 {
   cRepacker::Reset();
   skippedBytes = 0;
-  packetTodo = maxPacketSize - 6 - 3;
+  packetTodo = 0;
   fragmentLen = 0;
   pesHeaderLen = 0;
   pesHeaderBackupLen = 0;
@@ -161,8 +161,10 @@
      int PesPayloadOffset = 0;
      if (AnalyzePesHeader(fragmentData, fragmentLen, PesPayloadOffset) <= phInvalid)
         esyslog("cCommonRepacker: invalid PES packet encountered in fragment buffer!");
-     else if (6 + PacketLen <= PesPayloadOffset)
+     else if (6 + PacketLen <= PesPayloadOffset) {
+        fragmentLen = 0;
         return true; // skip empty packet
+        }
      // amount of data to put into result buffer: a negative Count value means
      // to strip off any partially contained start code.
      int Bite = fragmentLen + (Count >= 0 ? 0 : Count);
@@ -180,8 +182,10 @@
      int PesPayloadOffset = 0;
      if (AnalyzePesHeader(pesHeader, pesHeaderLen, PesPayloadOffset) <= phInvalid)
         esyslog("cCommonRepacker: invalid PES packet encountered in header buffer!");
-     else if (6 + PacketLen <= PesPayloadOffset)
+     else if (6 + PacketLen <= PesPayloadOffset) {
+        pesHeaderLen = 0;
         return true; // skip empty packet
+        }
      // amount of data to put into result buffer: a negative Count value means
      // to strip off any partially contained start code.
      int Bite = pesHeaderLen + (Count >= 0 ? 0 : Count);
@@ -361,7 +365,7 @@
         done++;
         todo--;
         // do we have to start a new packet as there is no more space left?
-        if (--packetTodo <= 0) {
+        if (state != syncing && --packetTodo <= 0) {
            // we connot start a new packet here if the current might end in a start
            // code and this start code shall possibly be put in the next packet. So
            // overfill the current packet until we can safely detect that we won't
@@ -468,6 +472,9 @@
 
 int cVideoRepacker::BreakAt(const uchar *Data, int Count)
 {
+  if (initiallySyncing)
+     return -1; // fill the packet buffer completely until we have synced once
+
   int PesPayloadOffset = 0;
 
   if (AnalyzePesHeader(Data, Count, PesPayloadOffset) <= phInvalid)
@@ -513,31 +520,31 @@
     } state;
   int frameTodo;
   int frameSize;
+  int cid;
   static bool IsValidAudioHeader(uint32_t Header, bool Mpeg2, int *FrameSize = NULL);
 public:
-  cAudioRepacker(void);
+  cAudioRepacker(int Cid);
   virtual void Reset(void);
   virtual void Repack(cRingBufferLinear *ResultBuffer, const uchar *Data, int Count);
   virtual int BreakAt(const uchar *Data, int Count);
   };
 
 int cAudioRepacker::bitRates[2][3][16] = { // all values are specified as kbits/s
-  // MPEG 1, Layer I
-  0,  32,  64,  96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448, -1,
-  // MPEG 1, Layer II
-  0,  32,  48,  56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320, 384, -1,
-  // MPEG 1, Layer III
-  0,  32,  40,  48,  56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320, -1,
-  // MPEG 2, Layer I
-  0,  32,  48,  56,  64,  80,  96, 112, 128, 144, 160, 176, 192, 224, 256, -1,
-  // MPEG 2, Layer II/III
-  0,   8,  16,  24,  32,  40,  48,  56,  64,  80,  96, 112, 128, 144, 160, -1,
-  // MPEG 2, Layer II/III
-  0,   8,  16,  24,  32,  40,  48,  56,  64,  80,  96, 112, 128, 144, 160, -1
+  {
+    { 0,  32,  64,  96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448, -1 }, // MPEG 1, Layer I
+    { 0,  32,  48,  56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320, 384, -1 }, // MPEG 1, Layer II
+    { 0,  32,  40,  48,  56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320, -1 }  // MPEG 1, Layer III
+  },
+  {
+    { 0,  32,  48,  56,  64,  80,  96, 112, 128, 144, 160, 176, 192, 224, 256, -1 }, // MPEG 2, Layer I
+    { 0,   8,  16,  24,  32,  40,  48,  56,  64,  80,  96, 112, 128, 144, 160, -1 }, // MPEG 2, Layer II/III
+    { 0,   8,  16,  24,  32,  40,  48,  56,  64,  80,  96, 112, 128, 144, 160, -1 }  // MPEG 2, Layer II/III
+  }
   };
 
-cAudioRepacker::cAudioRepacker(void)
+cAudioRepacker::cAudioRepacker(int Cid)
 {
+  cid = Cid;
   Reset();
 }
 
@@ -589,17 +596,13 @@
         *FrameSize = 0;
      else {
         static int samplingFrequencies[2][4] = { // all values are specified in Hz
-          // MPEG 1
-          44100, 48000, 32000, -1,
-          // MPEG 2
-          22050, 24000, 16000, -1
+          { 44100, 48000, 32000, -1 }, // MPEG 1
+          { 22050, 24000, 16000, -1 }  // MPEG 2
           };
 
         static int slots_per_frame[2][3] = {
-          // MPEG 1, Layer I, II, III
-          12, 144, 144,
-          // MPEG 2, Layer I, II, III
-          12, 144,  72
+          { 12, 144, 144 }, // MPEG 1, Layer I, II, III
+          { 12, 144,  72 }  // MPEG 2, Layer I, II, III
           };
 
         int mpegIndex = 1 - id;
@@ -652,21 +655,11 @@
         // collect number of skipped bytes while syncing
         if (state <= syncing)
            skippedBytes++;
-        else if (frameTodo > 0) {
-           frameTodo--;
-           if (frameTodo == 0 && state == scanFrame) {
-              // the current audio frame is is done now. So push out the packet to
-              // start a new packet for the next audio frame.
-              PushOutPacket(ResultBuffer, payload, data - payload);
-              // go on with syncing to the next audio frame
-              state = syncing;
-              }
-           }
         // did we reach an audio frame header?
         scanner <<= 8;
         scanner |= *data;
         if ((scanner & 0xFFF00000) == 0xFFF00000) {
-           if (frameTodo <= 0 && IsValidAudioHeader(scanner, mpegLevel == phMPEG2, &frameSize)) {
+           if (frameTodo <= 0 && (frameSize == 0 || skippedBytes >= 4) && IsValidAudioHeader(scanner, mpegLevel == phMPEG2, &frameSize)) {
               if (state == scanFrame) {
                  // As a new audio frame starts here, the previous one is done. So push
                  // out the packet to start a new packet for the next audio frame. If
@@ -681,7 +674,7 @@
                  if (initiallySyncing) // omit report for the typical initial case
                     initiallySyncing = false;
                  else if (skippedBytes > SkippedBytesLimit) // report that syncing dropped some bytes
-                    esyslog("cAudioRepacker: skipped %d bytes to sync on next audio frame", skippedBytes - SkippedBytesLimit);
+                    esyslog("cAudioRepacker(0x%02X): skipped %d bytes to sync on next audio frame", cid, skippedBytes - SkippedBytesLimit);
                  skippedBytes = 0;
                  // if there is a PES header available, then use it ...
                  if (pesHeaderBackupLen > 0) {
@@ -731,8 +724,18 @@
         data++;
         done++;
         todo--;
+        // do we have to start a new packet as the current is done?
+        if (frameTodo > 0) {
+           if (--frameTodo == 0) {
+              // the current audio frame is is done now. So push out the packet to
+              // start a new packet for the next audio frame.
+              PushOutPacket(ResultBuffer, payload, data - payload);
+              // go on with syncing to the next audio frame
+              state = syncing;
+              }
+           }
         // do we have to start a new packet as there is no more space left?
-        if (--packetTodo <= 0) {
+        if (state != syncing && --packetTodo <= 0) {
            // We connot start a new packet here if the current might end in an audio
            // frame header and this header shall possibly be put in the next packet. So
            // overfill the current packet until we can safely detect that we won't
@@ -829,13 +832,16 @@
   // report that syncing dropped some bytes
   if (skippedBytes > SkippedBytesLimit) {
      if (!initiallySyncing) // omit report for the typical initial case
-        esyslog("cAudioRepacker: skipped %d bytes while syncing on next audio frame", skippedBytes - SkippedBytesLimit);
+        esyslog("cAudioRepacker(0x%02X): skipped %d bytes while syncing on next audio frame", cid, skippedBytes - SkippedBytesLimit);
      skippedBytes = SkippedBytesLimit;
      }
 }
 
 int cAudioRepacker::BreakAt(const uchar *Data, int Count)
 {
+  if (initiallySyncing)
+     return -1; // fill the packet buffer completely until we have synced once
+
   int PesPayloadOffset = 0;
 
   ePesHeader MpegLevel = AnalyzePesHeader(Data, Count, PesPayloadOffset);
@@ -1189,6 +1195,8 @@
 
 int cDolbyRepacker::BreakAt(const uchar *Data, int Count)
 {
+  if (initiallySyncing)
+     return -1; // fill the packet buffer completely until we have synced once
   // enough data for test?
   if (Count < 6 + 3)
      return -1;
@@ -1263,7 +1271,7 @@
   int count;
   uint8_t *buf;
   uint8_t cid;
-  uint8_t audioCid;
+  uint8_t rewriteCid;
   uint8_t subStreamId;
   int plength;
   uint8_t plen[2];
@@ -1287,7 +1295,7 @@
   void write_ipack(const uint8_t *Data, int Count);
   void instant_repack(const uint8_t *Buf, int Count);
 public:
-  cTS2PES(int Pid, cRingBufferLinear *ResultBuffer, int Size, uint8_t AudioCid = 0x00, uint8_t SubStreamId = 0x00, cRepacker *Repacker = NULL);
+  cTS2PES(int Pid, cRingBufferLinear *ResultBuffer, int Size, uint8_t RewriteCid = 0x00, uint8_t SubStreamId = 0x00, cRepacker *Repacker = NULL);
   ~cTS2PES();
   int Pid(void) { return pid; }
   void ts_to_pes(const uint8_t *Buf); // don't need count (=188)
@@ -1296,12 +1304,12 @@
 
 uint8_t cTS2PES::headr[] = { 0x00, 0x00, 0x01 };
 
-cTS2PES::cTS2PES(int Pid, cRingBufferLinear *ResultBuffer, int Size, uint8_t AudioCid, uint8_t SubStreamId, cRepacker *Repacker)
+cTS2PES::cTS2PES(int Pid, cRingBufferLinear *ResultBuffer, int Size, uint8_t RewriteCid, uint8_t SubStreamId, cRepacker *Repacker)
 {
   pid = Pid;
   resultBuffer = ResultBuffer;
   size = Size;
-  audioCid = AudioCid;
+  rewriteCid = RewriteCid;
   subStreamId = SubStreamId;
   repacker = Repacker;
   if (repacker) {
@@ -1363,7 +1371,7 @@
 {
   if (count <= ((mpeg == 2) ? 9 : 7)) // skip empty packets
      return;
-  buf[3] = (AUDIO_STREAM_S <= cid && cid <= AUDIO_STREAM_E && audioCid) ? audioCid : cid;
+  buf[3] = rewriteCid ? rewriteCid : cid;
   buf[4] = (uint8_t)(((count - 6) & 0xFF00) >> 8);
   buf[5] = (uint8_t)((count - 6) & 0x00FF);
   store(buf, count);
@@ -1679,19 +1687,21 @@
   if (VPid)
 #define TEST_cVideoRepacker
 #ifdef TEST_cVideoRepacker
-     ts2pes[numTracks++] = new cTS2PES(VPid, resultBuffer, IPACKS, 0x00, 0x00, new cVideoRepacker);
+     ts2pes[numTracks++] = new cTS2PES(VPid, resultBuffer, IPACKS, 0xE0, 0x00, new cVideoRepacker);
 #else
-     ts2pes[numTracks++] = new cTS2PES(VPid, resultBuffer, IPACKS);
+     ts2pes[numTracks++] = new cTS2PES(VPid, resultBuffer, IPACKS, 0xE0);
 #endif
   if (APids) {
      int n = 0;
-     while (*APids && numTracks < MAXTRACKS && n < MAXAPIDS)
+     while (*APids && numTracks < MAXTRACKS && n < MAXAPIDS) {
 #define TEST_cAudioRepacker
 #ifdef TEST_cAudioRepacker
-           ts2pes[numTracks++] = new cTS2PES(*APids++, resultBuffer, IPACKS, 0xC0 + n++, 0x00, new cAudioRepacker);
+           ts2pes[numTracks++] = new cTS2PES(*APids++, resultBuffer, IPACKS, 0xC0 + n, 0x00, new cAudioRepacker(0xC0 + n));
+           n++;
 #else
            ts2pes[numTracks++] = new cTS2PES(*APids++, resultBuffer, IPACKS, 0xC0 + n++);
 #endif
+           }
      }
   if (DPids) {
      int n = 0;
diff -ruN vdr-1.3.31/summary2info.pl vdr-1.3.32/summary2info.pl
--- vdr-1.3.31/summary2info.pl	2005-06-04 13:33:09.000000000 +0200
+++ vdr-1.3.32/summary2info.pl	2005-09-10 14:40:40.000000000 +0200
@@ -10,7 +10,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: summary2info.pl 1.3 2005/06/04 11:33:09 kls Exp $
+# $Id: summary2info.pl 1.4 2005/09/10 12:40:40 kls Exp $
 
 $VideoDir = $ARGV[0] || die "please provide the name of the video directory\n";
 
@@ -37,6 +37,15 @@
        $data[2] = $data[1];
        $data[1] = "";
        }
+    elsif ($line == 2) {
+       # if line 1 is too long, it can't be the short text,
+       # so assume the short text is missing and concatenate
+       # line 1 and line 2 to be the long text:
+       if (length($data[1]) > 80) { 
+          $data[2] = $data[1] . "|" . $data[2];
+          $data[1] = "";
+          }
+       }
     ($InfoFile = $SummaryFile) =~ s/summary\.vdr$/info.vdr/;
     open(F, ">$InfoFile") || die "$InfoFile: $!\n";
     print F "T $data[0]\n" if ($data[0]);
diff -ruN vdr-1.3.31/svdrp.c vdr-1.3.32/svdrp.c
--- vdr-1.3.31/svdrp.c	2005-08-28 16:12:00.000000000 +0200
+++ vdr-1.3.32/svdrp.c	2005-09-03 16:09:02.000000000 +0200
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 1.77 2005/08/28 14:12:00 kls Exp $
+ * $Id: svdrp.c 1.80 2005/09/03 14:09:02 kls Exp $
  */
 
 #include "svdrp.h"
@@ -269,12 +269,16 @@
   "    at the position where any previous replay was stopped, or from the beginning\n"
   "    by default. To control or stop the replay session, use the usual remote\n"
   "    control keypresses via the HITK command.",
-  "PLUG <name> [ <command> [ <options> ]]\n"
+  "PLUG <name> [ help | main ] [ <command> [ <options> ]]\n"
   "    Send a command to a plugin.\n"
   "    The PLUG command without any parameters lists all plugins.\n"
   "    If only a name is given, all commands known to that plugin are listed.\n"
   "    If a command is given (optionally followed by parameters), that command\n"
-  "    is sent to the plugin, and the result will be displayed.",
+  "    is sent to the plugin, and the result will be displayed.\n"
+  "    The keyword 'help' lists all the SVDRP commands known to the named plugin.\n"
+  "    If 'help' is followed by a command, the detailed help for that command is\n"
+  "    given. The keyword 'main' initiates a call to the main menu function of the\n"
+  "    given plugin.\n",
   "PUTE\n"
   "    Put data into the EPG list. The data entered has to strictly follow the\n"
   "    format defined in vdr(5) for the 'epg.data' file.  A '.' on a line\n"
@@ -1035,8 +1039,51 @@
 
 void cSVDRP::CmdMOVC(const char *Option)
 {
-  //TODO combine this with menu action (timers must be updated)
-  Reply(502, "MOVC not yet implemented");
+  if (*Option) {
+     if (!Channels.BeingEdited() && !Timers.BeingEdited()) {
+        char *tail;
+        int From = strtol(Option, &tail, 10);
+        if (tail && tail != Option) {
+           tail = skipspace(tail);
+           if (tail && tail != Option) {
+              int To = strtol(tail, NULL, 10);
+              int CurrentChannelNr = cDevice::CurrentChannel();
+              cChannel *CurrentChannel = Channels.GetByNumber(CurrentChannelNr);
+              cChannel *FromChannel = Channels.GetByNumber(From);
+              if (FromChannel) {
+                 cChannel *ToChannel = Channels.GetByNumber(To);
+                 if (ToChannel) {
+                    int FromNumber = FromChannel->Number();
+                    int ToNumber = ToChannel->Number();
+                    if (FromNumber != ToNumber) {
+                       Channels.Move(FromChannel, ToChannel);
+                       Channels.ReNumber();
+                       Channels.SetModified(true);
+                       if (CurrentChannel && CurrentChannel->Number() != CurrentChannelNr)
+                          Channels.SwitchTo(CurrentChannel->Number());
+                       isyslog("channel %d moved to %d", FromNumber, ToNumber);
+                       Reply(250,"Channel \"%d\" moved to \"%d\"", From, To);
+                       }
+                    else
+                       Reply(501, "Can't move channel to same postion");
+                    }
+                 else
+                    Reply(501, "Channel \"%d\" not defined", To);
+                 }
+              else
+                 Reply(501, "Channel \"%d\" not defined", From);
+              }
+           else
+              Reply(501, "Error in channel number");
+           }
+        else
+           Reply(501, "Error in channel number");
+        }
+     else
+        Reply(550, "Channels or timers are being edited - try again later");
+     }
+  else
+     Reply(501, "Missing channel number");
 }
 
 void cSVDRP::CmdMOVT(const char *Option)
@@ -1204,6 +1251,10 @@
                  Reply(214, "This plugin has no SVDRP commands");
               }
            }
+        else if (strcasecmp(cmd, "MAIN") == 0) {
+           cRemote::CallPlugin(plugin->Name());
+           Reply(250, "Initiated call to main menu function of plugin \"%s\"", plugin->Name());
+           }
         else {
            int ReplyCode = 900;
            cString s = plugin->SVDRPCommand(cmd, option, ReplyCode);
diff -ruN vdr-1.3.31/timers.c vdr-1.3.32/timers.c
--- vdr-1.3.31/timers.c	2005-07-30 15:03:51.000000000 +0200
+++ vdr-1.3.32/timers.c	2005-09-09 17:22:33.000000000 +0200
@@ -4,12 +4,13 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.c 1.34 2005/07/30 13:03:51 kls Exp $
+ * $Id: timers.c 1.36 2005/09/09 15:22:33 kls Exp $
  */
 
 #include "timers.h"
 #include <ctype.h>
 #include "channels.h"
+#include "device.h"
 #include "i18n.h"
 #include "remote.h"
 
@@ -518,7 +519,10 @@
 cTimer *cTimers::GetTimer(cTimer *Timer)
 {
   for (cTimer *ti = First(); ti; ti = Next(ti)) {
-      if (ti->Channel() == Timer->Channel() && ti->Day() == Timer->Day() && ti->Start() == Timer->Start() && ti->Stop() == Timer->Stop())
+      if (ti->Channel() == Timer->Channel() &&
+          (ti->WeekDays() && ti->WeekDays() == Timer->WeekDays() || !ti->WeekDays() && ti->Day() == Timer->Day()) &&
+          ti->Start() == Timer->Start() &&
+          ti->Stop() == Timer->Stop())
          return ti;
       }
   return NULL;
diff -ruN vdr-1.3.31/tools.c vdr-1.3.32/tools.c
--- vdr-1.3.31/tools.c	2005-08-27 16:43:55.000000000 +0200
+++ vdr-1.3.32/tools.c	2005-09-11 15:11:05.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 1.97 2005/08/27 14:43:55 kls Exp $
+ * $Id: tools.c 1.98 2005/09/11 13:11:05 kls Exp $
  */
 
 #include "tools.h"
@@ -1080,8 +1080,7 @@
 
 cHashBase::~cHashBase(void)
 {
-  for (int i = 0; i < size; i++)
-      delete hashTable[i];
+  Clear();
   free(hashTable);
 }
 
@@ -1106,6 +1105,14 @@
      }
 }
 
+void cHashBase::Clear(void)
+{
+  for (int i = 0; i < size; i++) {
+      delete hashTable[i];
+      hashTable[i] = NULL;
+      }
+}
+
 cListObject *cHashBase::Get(unsigned int Id) const
 {
   cList<cHashObject> *list = hashTable[hashfn(Id)];
diff -ruN vdr-1.3.31/tools.h vdr-1.3.32/tools.h
--- vdr-1.3.31/tools.h	2005-08-27 16:40:08.000000000 +0200
+++ vdr-1.3.32/tools.h	2005-09-11 15:04:03.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 1.75 2005/08/27 14:40:08 kls Exp $
+ * $Id: tools.h 1.76 2005/09/11 13:04:03 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -259,6 +259,7 @@
   cListObject *object;
 public:
   cHashObject(cListObject *Object, unsigned int Id) { object = Object; id = Id; }
+  cListObject *Object(void) { return object; }
   };
 
 class cHashBase {
@@ -272,6 +273,7 @@
   virtual ~cHashBase();
   void Add(cListObject *Object, unsigned int Id);
   void Del(cListObject *Object, unsigned int Id);
+  void Clear(void);
   cListObject *Get(unsigned int Id) const;
   cList<cHashObject> *GetList(unsigned int Id) const;
   };
diff -ruN vdr-1.3.31/vdr.c vdr-1.3.32/vdr.c
--- vdr-1.3.31/vdr.c	2005-08-21 10:47:06.000000000 +0200
+++ vdr-1.3.32/vdr.c	2005-09-04 10:57:15.000000000 +0200
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 1.211 2005/08/21 08:47:06 kls Exp $
+ * $Id: vdr.c 1.216 2005/09/04 08:57:15 kls Exp $
  */
 
 #include <getopt.h>
@@ -66,6 +66,7 @@
 #define LASTCAMMENUTIMEOUT  3 // seconds to run the main loop 'fast' after a CAM menu has been closed
                               // in order to react on a possible new CAM menu as soon as possible
 #define DEVICEREADYTIMEOUT 30 // seconds to wait until all devices are ready
+#define MENUTIMEOUT       120 // seconds of user inactivity after which an OSD display is closed
 
 #define EXIT(v) { ExitCode = (v); goto Exit; }
 
@@ -130,6 +131,9 @@
 #elif defined(REMOTE_RCU)
   RcuDevice = RCU_DEVICE;
 #endif
+#if defined(VFAT)
+  VfatFileSystem = true;
+#endif
 
   cPluginManager PluginManager(DEFAULTPLUGINDIR);
   int ExitCode = 0;
@@ -153,6 +157,7 @@
       { "shutdown", required_argument, NULL, 's' },
       { "terminal", required_argument, NULL, 't' },
       { "version",  no_argument,       NULL, 'V' },
+      { "vfat",     no_argument,       NULL, 'v' | 0x100 },
       { "video",    required_argument, NULL, 'v' },
       { "watchdog", required_argument, NULL, 'w' },
       { NULL }
@@ -245,6 +250,9 @@
                     break;
           case 'V': DisplayVersion = true;
                     break;
+          case 'v' | 0x100:
+                    VfatFileSystem = true;
+                    break;
           case 'v': VideoDirectory = optarg;
                     while (optarg && *optarg && optarg[strlen(optarg) - 1] == '/')
                           optarg[strlen(optarg) - 1] = 0;
@@ -303,6 +311,8 @@
                "  -t TTY,   --terminal=TTY controlling tty\n"
                "  -v DIR,   --video=DIR    use DIR as video directory (default: %s)\n"
                "  -V,       --version      print version information and exit\n"
+               "            --vfat         encode special characters in recording names to\n"
+               "                           avoid problems with VFAT file systems\n"
                "  -w SEC,   --watchdog=SEC activate the watchdog timer with a timeout of SEC\n"
                "                           seconds (default: %d); '0' disables the watchdog\n"
                "\n",
@@ -695,7 +705,7 @@
                Menu = new cMenuMain(cControl::Control());
                Temp = NULL;
                break;
-          #define DirectMainFunction(function...)\
+          #define DirectMainFunction(function)\
             DELETENULL(Menu);\
             if (cControl::Control())\
                cControl::Control()->Hide();\
@@ -709,7 +719,25 @@
           case kSetup:      DirectMainFunction(osSetup); break;
           case kCommands:   DirectMainFunction(osCommands); break;
           case kUser1 ... kUser9: cRemote::PutMacro(key); key = kNone; break;
-          case k_Plugin:    DirectMainFunction(osPlugin, cRemote::GetPlugin()); break;
+          case k_Plugin: {
+               DELETENULL(Menu);
+               Temp = NULL;
+               if (cControl::Control())
+                  cControl::Control()->Hide();
+               cPlugin *plugin = cPluginManager::GetPlugin(cRemote::GetPlugin());
+               if (plugin) {
+                  Menu = Temp = plugin->MainMenuAction();
+                  if (Menu) {
+                     Menu->Show();
+                     if (Menu->IsMenu())
+                        ((cOsdMenu*)Menu)->Display();
+                     }
+                  }
+               else
+                  esyslog("ERROR: unknown plugin '%s'", cRemote::GetPlugin());
+               key = kNone; // nobody else needs to see these keys
+               }
+               break;
           // Channel up/down:
           case kChanUp|k_Repeat:
           case kChanUp:
@@ -790,8 +818,12 @@
         Interact = Menu ? Menu : cControl::Control(); // might have been closed in the mean time
         if (Interact) {
            eOSState state = Interact->ProcessKey(key);
-           if (state == osUnknown && ISMODELESSKEY(key) && cControl::Control() && Interact != cControl::Control())
-              state = cControl::Control()->ProcessKey(key);
+           if (state == osUnknown && Interact != cControl::Control()) {
+              if (ISMODELESSKEY(key) && cControl::Control())
+                 state = cControl::Control()->ProcessKey(key);
+              else if (time(NULL) - LastActivity > MENUTIMEOUT)
+                 state = osEnd;
+              }
            switch (state) {
              case osPause:  DELETENULL(Menu);
                             cControl::Shutdown(); // just in case
